package cn.yyxx.eyuangame.core.impl.center

import android.app.Dialog
import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Handler
import android.os.Looper
import android.os.Message
import android.text.TextUtils
import android.view.*
import android.widget.*
import androidx.constraintlayout.widget.ConstraintLayout
import cn.yyxx.eyuangame.base.utils.Logger
import cn.yyxx.eyuangame.core.entity.ResultInfo
import cn.yyxx.eyuangame.core.entity.SdkBackLoginInfo
import cn.yyxx.eyuangame.core.impl.SdkBridgeImpl
import cn.yyxx.eyuangame.core.internal.IImplCallback
import cn.yyxx.eyuangame.core.internal.IRequestCallback
import cn.yyxx.eyuangame.core.network.SdkRequest
import cn.yyxx.eyuangame.core.ui.EventEditText
import cn.yyxx.eyuangame.core.utils.EditTextUtils
import cn.yyxx.eyuangame.core.utils.TimeDownUtils
import cn.yyxx.support.DensityUtils
import cn.yyxx.support.ResUtils
import cn.yyxx.support.hawkeye.ToastUtils
import org.json.JSONObject

/**
 * @author #Suyghur.
 * Created on 2021/12/23
 */
class BindPhoneContainer(context: Context, private val callback: IImplCallback) : Dialog(context) {
    private lateinit var llGroup1: LinearLayout
    private lateinit var llGroup2: LinearLayout
    private lateinit var clTips: ConstraintLayout

    private lateinit var ivReturn: ImageView
    private lateinit var eetPhone: EventEditText
    private lateinit var eetCaptcha: EventEditText
    private lateinit var btnCaptCha: Button
    private lateinit var btnConfirm: Button
    private lateinit var tvArea: TextView
    private lateinit var ivArrow: ImageView
    private lateinit var tvBindTips: TextView

    private lateinit var rlAreaList: RelativeLayout
    private lateinit var llAreaList: LinearLayout
    private lateinit var svAreaList: ScrollView

    private val areaCodeList = mutableListOf<String>()

    private var imgUp = 0
    private var imgDown = 0

    private var code = ""

    private val handler = object : Handler(Looper.getMainLooper()) {
        override fun handleMessage(msg: Message) {
            if (msg.what == 101) {
                changeTimeView(msg.obj as Int)
            }
        }
    }

    init {
        setCanceledOnTouchOutside(true)
        window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        initView(context)
    }

    private fun initView(context: Context) {
        setContentView(ResUtils.getResId(context, "yyxx_member_bind_phone", "layout"))

        val attr = window?.attributes as WindowManager.LayoutParams
        attr.height = DensityUtils.dip2px(context, 250f)
        if (SdkBridgeImpl.isLand) {
            attr.width = DensityUtils.getHeightAndWidth(context)[0] / 2
        } else {
            attr.width = DensityUtils.getHeightAndWidth(context)[0] - 80
        }
        attr.gravity = Gravity.CENTER

        imgUp = ResUtils.getResId(context, "yyxx_pack_up_white_img", "drawable")
        imgDown = ResUtils.getResId(context, "yyxx_pack_down_white_img", "drawable")

        ivReturn = findViewById(ResUtils.getResId(context, "yyxx_iv_return", "id"))

        ivReturn.setOnClickListener {
            dismiss()

        }

        llGroup1 = findViewById(ResUtils.getResId(context, "yyxx_ll_group1", "id"))
        llGroup2 = findViewById(ResUtils.getResId(context, "yyxx_ll_group2", "id"))
        clTips = findViewById(ResUtils.getResId(context, "yyxx_cl_tips", "id"))

        eetPhone = findViewById(ResUtils.getResId(context, "yyxx_eet_phone", "id"))
        eetPhone.editText.hint = ResUtils.getResString(context, "yyxx_hint_forget_phone")

        eetCaptcha = findViewById(ResUtils.getResId(context, "yyxx_eet_captcha", "id"))
        eetCaptcha.editText.hint = ResUtils.getResString(context, "yyxx_hint_bind_phone_captcha")

        btnCaptCha = findViewById(ResUtils.getResId(context, "yyxx_btn_captcha", "id"))
        btnCaptCha.setOnClickListener {
            callGetCaptcha()
        }


        btnConfirm = findViewById(ResUtils.getResId(context, "yyxx_btn_confirm", "id"))
        btnConfirm.setOnClickListener {
            callBindPhone()
        }

        rlAreaList = findViewById(ResUtils.getResId(context, "yyxx_rl_area_list", "id"))
        rlAreaList.visibility = View.GONE
        llAreaList = findViewById(ResUtils.getResId(context, "yyxx_ll_area_list", "id"))
        svAreaList = findViewById(ResUtils.getResId(context, "yyxx_sv_area_list", "id"))


        tvArea = findViewById(ResUtils.getResId(context, "yyxx_tv_area", "id"))
        ivArrow = findViewById(ResUtils.getResId(context, "yyxx_iv_arrow", "id"))
        ivArrow.setOnClickListener {
            changeAreaList()
        }

        autoFillAreaList(context)

        tvBindTips = findViewById(ResUtils.getResId(context, "yyxx_tv_tips2", "id"))
        val tipsPhone = if (SdkBackLoginInfo.instance.phoneNum.length > 6) {
            val head = SdkBackLoginInfo.instance.phoneNum.substring(0, 3)
            val foot = SdkBackLoginInfo.instance.phoneNum.substring(SdkBackLoginInfo.instance.phoneNum.length - 3, SdkBackLoginInfo.instance.phoneNum.length)
            "${head}xxxx${foot}"
        } else {
            SdkBackLoginInfo.instance.phoneNum
        }
        tvBindTips.text = "${ResUtils.getResString(context, "yyxx_iv_bind_phone_tips2")}$tipsPhone"

        showOrHideTips()
    }

    private fun autoFillAreaList(context: Context) {
        if (SdkBridgeImpl.initBean.areaCodeList.isNullOrEmpty()) {
            //默认4个地区
            areaCodeList.add("86")
            //香港
            areaCodeList.add("852")
            //澳门
            areaCodeList.add("853")
            //台湾
            areaCodeList.add("886")
        } else {
            SdkBridgeImpl.initBean.areaCodeList.forEach {
                areaCodeList.add(it)
            }
        }
        initAreaList(context)
    }

    private fun initAreaList(context: Context) {
        llAreaList.removeAllViews()
        //单行高
        var height = 100
        tvArea.apply {
            height = if (layoutParams != null) {
                layoutParams!!.height
            } else {
                100
            }
        }
        //ScrollView高度
        var maxHeight = 0
        areaCodeList.apply {
            maxHeight = if (size < 2) {
                size * height
            } else {
                2 * height
            }
        }
        //循环添加列
        areaCodeList.apply {
            for (i in indices) {
                val areaCode = this[i]
                //添加线
                val line = View(context)
                line.layoutParams = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, 2)
                line.setBackgroundColor(Color.parseColor("#E6FFFFFF"))
                llAreaList.apply {
                    if (childCount > 0) {
                        addView(line)
                    }
                }
                //添加区号
                val item = LayoutInflater.from(context).inflate(ResUtils.getResId(context, "yyxx_area_list_item", "layout"), null)
                item?.apply {
                    val tvAreaCode = findViewById<TextView>(ResUtils.getResId(context, "yyxx_tv_area", "id"))
                    tvAreaCode.gravity = Gravity.CENTER
                    tvAreaCode.text = areaCode
                    setOnClickListener(OnItemClick(areaCode))
                    layoutParams = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, height)
                    llAreaList.addView(this, llAreaList.childCount)
                }
            }
        }
        svAreaList.layoutParams = RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.MATCH_PARENT, maxHeight)
    }


    private fun changeAreaList() {
        if (rlAreaList.visibility == View.GONE) {
            ivArrow.setBackgroundResource(imgUp)
            rlAreaList.visibility = View.VISIBLE
        } else {
            ivArrow.setBackgroundResource(imgDown)
            rlAreaList.visibility = View.GONE
        }
    }

    private fun callGetCaptcha() {
        val areaCode = code
        Logger.d("$areaCode ...")
        val phoneNum = eetPhone.editText.text.trim().toString()

        if (TextUtils.isEmpty(areaCode) || areaCode == ResUtils.getResString(context, "yyxx_tv_area_code")) {
            ToastUtils.toastInfo(context, ResUtils.getResString(context, "yyxx_tips_area_code_format_error"))
            return
        }

        if (!EditTextUtils.filterPwd(phoneNum)) {
            ToastUtils.toastInfo(context, ResUtils.getResString(context, "yyxx_tips_phone_format_error"))
            return
        }

        try {
            with(JSONObject()) {
                put("sms_type", "bind_phone")
                put("area_code", areaCode)
                put("phone_number", phoneNum)
                SdkRequest.instance.getCaptcha(context, this, object : IRequestCallback {
                    override fun onResponse(resultInfo: ResultInfo) {
                        if (resultInfo.code == 1) {
                            ToastUtils.toastInfo(context, resultInfo.msg)
                            changeTimeNum()
                        } else {
                            ToastUtils.toastInfo(context, resultInfo.msg)
                        }
                    }
                })
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    private fun callBindPhone() {
        val phoneNum = eetPhone.editText.text.trim().toString()
        val captcha = eetCaptcha.editText.text.trim().toString()

        if (TextUtils.isEmpty(captcha)) {
            ToastUtils.toastInfo(context, ResUtils.getResString(context, "yyxx_tips_captcha_format_error"))
            return
        }
        if (!EditTextUtils.filterPhone(phoneNum)) {
            ToastUtils.toastInfo(context, ResUtils.getResString(context, "yyxx_tips_phone_format_error"))
            return
        }

        try {
            with(JSONObject()) {
                put("uid", SdkBackLoginInfo.instance.userId)
                put("phone_number", phoneNum)
                put("sms_code", captcha)
                SdkRequest.instance.bindPhone(context, this, object : IRequestCallback {
                    override fun onResponse(resultInfo: ResultInfo) {
                        if (resultInfo.code == 1) {
                            SdkBackLoginInfo.instance.phoneNum = phoneNum
                            ToastUtils.toastInfo(context, resultInfo.msg)
                            callback.onResult(0, resultInfo.msg)
                            dismiss()
                        } else {
                            ToastUtils.toastInfo(context, resultInfo.msg)
                        }
                    }
                })
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    private fun changeTimeView(time: Int) {
        btnCaptCha.apply {
            text = if (time <= 0) {
                this.isEnabled = true
                ResUtils.getResString(context, "yyxx_tv_get_captcha")
            } else {
                this.isEnabled = false
                "${time}s"
            }
        }
    }

    private fun changeTimeNum() {
        if (!TimeDownUtils.isRunning) {
            TimeDownUtils.start(60, object : TimeDownUtils.TimeCallback {
                override fun onTime(time: Int) {
                    val msg = Message.obtain()
                    msg.what = 101
                    msg.obj = time
                    handler.sendMessage(msg)
                }
            })
        } else {
            TimeDownUtils.resetCallback(object : TimeDownUtils.TimeCallback {
                override fun onTime(time: Int) {
                    val msg = Message.obtain()
                    msg.what = 101
                    msg.obj = time
                    handler.sendMessage(msg)
                }
            })
        }
    }

    private fun showOrHideTips() {
        if (TextUtils.isEmpty(SdkBackLoginInfo.instance.phoneNum)) {
            llGroup1.visibility = View.VISIBLE
            llGroup2.visibility = View.VISIBLE
            clTips.visibility = View.GONE
            btnConfirm.visibility = View.VISIBLE
        } else {
            llGroup1.visibility = View.GONE
            llGroup2.visibility = View.GONE
            clTips.visibility = View.VISIBLE
            btnConfirm.visibility = View.GONE
        }
    }


    /**
     * 账号列表item点击事件
     */
    private inner class OnItemClick(val areaCode: String) : View.OnClickListener {
        override fun onClick(v: View?) {
            tvArea.apply {
                changeAreaList()
                tvArea.text = areaCode
                this@BindPhoneContainer.code = areaCode
            }
        }
    }
}